<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>You want sudo -i or su -</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">

<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<div class="post-date">14 Feb 2021</div><h1 class="post-title"><a href="2021-02-14-you-want-sudo--i-or-su--.html">You want sudo -i or su -</a></h1>
<p>
You want to use <code>sudo -i</code> or <code>su -</code> to log into root.  <code>sudo su</code> <i>anything</i> is
superfluous, because you probably should be using <code>sudo -i</code> or <code>sudo -s</code>, which are
roughly equivalent, depending if you want to simulate a login (<code>su -</code> or <code>sudo
-i</code>) or not (<code>su</code> or <code>sudo -s</code>).<sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>
</p>
<div id="outline-container-orgc9daa99" class="outline-2">
<h2 id="orgc9daa99">When to use <code>su -</code>?</h2>
<div class="outline-text-2" id="text-orgc9daa99">
<p>
You want to log into root using the root password.  Typically you must be in
the <code>wheel</code> group (check your PAM configuration).  In Debian, you simply need
to know the password, as <a href="https://sources.debian.org/src/util-linux/2.36.1-7/debian/util-linux.su.pam/#L8">there is no <code>wheel</code> group restriction enabled by
default</a>.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>
</p>
</div>
</div>
<div id="outline-container-org75388e9" class="outline-2">
<h2 id="org75388e9">When to use <code>sudo -i</code>?</h2>
<div class="outline-text-2" id="text-org75388e9">
<p>
You want to log into root using your sudo configuration, which will typically
prompt for your login password or allow login without a password.  <code>sudo</code> also
logs all invocations by default.  It is also more flexible, but is also prone
to security concerns, such as the <a href="https://www.sudo.ws/alerts/unescape_overflow.html">recent local user escalation vulnerability</a>.
It's not crazy to consider using just <code>su -</code> or maybe some other tool like
<a href="https://man.openbsd.org/doas"><code>doas</code></a>, <code>sudo</code> is a bit hard to pin down when assessing its security risks.
</p>
</div>
</div>
<div id="outline-container-orge78fb22" class="outline-2">
<h2 id="orge78fb22">Why do I want to "simulate a login"?</h2>
<div class="outline-text-2" id="text-orge78fb22">
<p>
The next few sections show some diffs of <code>env(1)</code> output.  The diff is
generated using <code>diff -U0 | grep -v '^@'</code>.  This shows an unified diff with no
context and suppresses line markers.  First I'll summarize what the output
suggests, then show the diffs.
</p>
</div>
<div id="outline-container-orga7f9dc4" class="outline-3">
<h3 id="orga7f9dc4">TL;DR</h3>
<div class="outline-text-3" id="text-orga7f9dc4">
<p>
In my case, if I don't use <code>sudo -i</code> or <code>su -</code> to simulate<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup> a login the
following things might not work correctly:
</p>
<ul class="org-ul">
<li>Not exactly sure what the missing settings mean for <a href="https://nixos.org/">nix</a>, though I'm going to
guess root won't be able to use nix without a login.</li>
<li>the pager settings won't be configured correctly</li>
<li>SBCL, Java, Dotnet, VBox, Fltk, OpenCL, Distcc might not work</li>
<li>Plan9port might not work</li>
<li><a href="https://github.com/sudo-project/sudo/blob/7f3c670a13cb584b04ba9c9dd4d7ae457460ebda/plugins/sudoers/env.c#L213-L228"><code>sudo</code> will allow <code>XAUTHORITY</code> on through</a>, which permits you to run graphical
programs as another user, using the current user's desktop session.  So using
<code>su</code> may not pass this on through by default.  (Maybe <code>su -m</code> could do this as well?)</li>
</ul>

<p>
Simulating login also sets your <code>PWD</code> to root's <code>HOME</code> (<code>/root</code>).  This might
seem convenient at first.  I wonder why one would want to touch their user
files as root.  The use-cases might be (1) write a thumb drive, (2) grab some
system configuration from your user's homedir, or (3) You store system stuff in
your home directory.  Maybe logging into root's homedir is a saner default,
then just specify an absolute path to be extra clear what you wanted to do.
This also means if you do something dumb, it will not damage your user homedir,
only root's, provided you didn't <code>cd</code> somewhere else.
</p>


<p>
It most of these settings are pulled in from my <code>/etc/profile</code>.  Hence you
probably want to simulate a user login.
</p>
</div>
</div>
<div id="outline-container-orgfa89917" class="outline-3">
<h3 id="orgfa89917">The <code>env</code> diffs</h3>
<div class="outline-text-3" id="text-orgfa89917">
</div>
<div id="outline-container-org86e574d" class="outline-4">
<h4 id="org86e574d"><code>sudo -s</code> vs <code>sudo -i</code></h4>
<div class="outline-text-4" id="text-org86e574d">
<div class="org-src-container">
<pre class="src src-diff"><span style="background-color: #5f5f5f;">--- </span><span style="color: #dcdccc; background-color: #5f5f5f; font-weight: bold;">sudo_-s</span><span style="background-color: #5f5f5f;">     2021-02-14 17:26:26.912620999 -0600</span>
<span style="background-color: #5f5f5f;">+++ </span><span style="color: #dcdccc; background-color: #5f5f5f; font-weight: bold;">sudo_-i</span><span style="background-color: #5f5f5f;">     2021-02-14 17:26:38.259214818 -0600</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PLAN9=/opt/plan9</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">XDG_CONFIG_DIRS=/etc/xdg</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LESS=-R -M --shift 5</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JDK_HOME=/etc/java-config-2/current-system-vm</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">CONFIG_PROTECT_MASK=/etc/sandbox.d /etc/fonts/fonts.conf /etc/gentoo-release /etc/gconf /etc/terminfo /etc/dconf /etc/ca-certificates.conf /etc/texmf/web2c /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/revdep-rebuild</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_VERBOSE=0</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JAVA_HOME=/etc/java-config-2/current-system-vm</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DOTNET_ROOT=/opt/dotnet_core</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">ANT_HOME=/usr/share/ant</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">PWD=/home/winston</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">EDITOR=/usr/bin/vi</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PWD=/root</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_PROFILES=/nix/var/nix/profiles/default /root/.nix-profile</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">CONFIG_PROTECT=/etc/stunnel/stunnel.conf /usr/share/maven-bin-3.6/conf /usr/share/gnupg/qualified.txt /usr/share/easy-rsa /usr/share/config /usr/lib64/libreoffice/program/sofficerc</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">QT_QPA_PLATFORMTHEME=qt5ct</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_TCP_CORK=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">MANPATH=/root/.nix-profile/share/man:/etc/java-config-2/current-system-vm/man:/usr/share/gcc-data/x86_64-pc-linux-gnu/9.3.0/man:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.35.1/man:/etc/java-config-2/current-system-vm/man/:/usr/local/share/man:/usr/share/man:/usr/lib/rust/man:/usr/lib/llvm/11/share/man:/opt/plan9/man</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_PATH=nixpkgs=/nix/var/nix/profiles/per-user/root/channels/nixpkgs:/nix/var/nix/profiles/per-user/root/channels:/root/.nix-defexpr/channels</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">OPENCL_PROFILE=nvidia</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">UNCACHED_ERR_FD=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">FLTK_DOCDIR=/usr/share/doc/fltk-1.3.5-r4/html</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_SSL_CERT_FILE=/etc/ssl/certs/ca-certificates.crt</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">OPENGL_PROFILE=xorg-x11</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_FALLBACK=1</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DCC_EMAILLOG_WHOM_TO_BLAME=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">INFOPATH=/usr/share/gcc-data/x86_64-pc-linux-gnu/9.3.0/info:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.35.1/info:/usr/share/info:/usr/share/info/emacs-26</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JAVAC=/etc/java-config-2/current-system-vm/bin/javac</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LESSOPEN=|lesspipe %s</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">MANPAGER=manpager</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin:/usr/lib/llvm/11/bin:/opt/plan9/bin</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_SAVE_TEMPS=0</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PAGER=/usr/bin/less</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_SSH=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">SBCL_HOME=/usr/lib64/sbcl</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">GCC_SPECS=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">GSETTINGS_BACKEND=dconf</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_ENABLE_DISCREPANCY_EMAIL=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">XDG_DATA_DIRS=/usr/local/share:/usr/share</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PATH=/root/.nix-profile/bin:/root/.nix-profile/bin:/nix/var/nix/profiles/default/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin:/usr/lib/llvm/11/bin:/opt/plan9/bin:/usr/games/bin</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">VBOX_APP_HOME=/usr/lib64/virtualbox</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LV2_PATH=/usr/lib64/lv2</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">_=/bin/env</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">SBCL_SOURCE_ROOT=/usr/lib64/sbcl/src</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LADSPA_PATH=/usr/lib64/ladspa</span>
+_=/usr/bin/env
</pre>
</div>
</div>
</div>

<div id="outline-container-orgafb098a" class="outline-4">
<h4 id="orgafb098a"><code>sudo su</code> vs <code>sudo su -</code></h4>
<div class="outline-text-4" id="text-orgafb098a">
<p>
I don't have a root password set on my systems, so I will use <code>sudo</code> with <code>su</code>
for example's sake.
</p>

<div class="org-src-container">
<pre class="src src-diff"><span style="background-color: #5f5f5f;">--- </span><span style="color: #dcdccc; background-color: #5f5f5f; font-weight: bold;">sudo_su</span><span style="background-color: #5f5f5f;">     2021-02-14 17:25:53.932832743 -0600</span>
<span style="background-color: #5f5f5f;">+++ </span><span style="color: #dcdccc; background-color: #5f5f5f; font-weight: bold;">sudo_su_-</span><span style="background-color: #5f5f5f;">   2021-02-14 17:26:10.259394587 -0600</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PLAN9=/opt/plan9</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">SUDO_GID=1000</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">SUDO_COMMAND=/bin/su</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">SUDO_USER=winston</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">PWD=/home/winston</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">XDG_CONFIG_DIRS=/etc/xdg</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LESS=-R -M --shift 5</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JDK_HOME=/etc/java-config-2/current-system-vm</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">CONFIG_PROTECT_MASK=/etc/sandbox.d /etc/fonts/fonts.conf /etc/gentoo-release /etc/gconf /etc/terminfo /etc/dconf /etc/ca-certificates.conf /etc/texmf/web2c /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/revdep-rebuild</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_VERBOSE=0</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JAVA_HOME=/etc/java-config-2/current-system-vm</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DOTNET_ROOT=/opt/dotnet_core</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">ANT_HOME=/usr/share/ant</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">EDITOR=/usr/bin/vi</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PWD=/root</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_PROFILES=/nix/var/nix/profiles/default /root/.nix-profile</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">CONFIG_PROTECT=/etc/stunnel/stunnel.conf /usr/share/maven-bin-3.6/conf /usr/share/gnupg/qualified.txt /usr/share/easy-rsa /usr/share/config /usr/lib64/libreoffice/program/sofficerc</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">XAUTHORITY=/root/.xauthgcUQue</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">QT_QPA_PLATFORMTHEME=qt5ct</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_TCP_CORK=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">MANPATH=/root/.nix-profile/share/man:/etc/java-config-2/current-system-vm/man:/usr/share/gcc-data/x86_64-pc-linux-gnu/9.3.0/man:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.35.1/man:/etc/java-config-2/current-system-vm/man/:/usr/local/share/man:/usr/share/man:/usr/lib/rust/man:/usr/lib/llvm/11/share/man:/opt/plan9/man</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_PATH=nixpkgs=/nix/var/nix/profiles/per-user/root/channels/nixpkgs:/nix/var/nix/profiles/per-user/root/channels:/root/.nix-defexpr/channels</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">XAUTHORITY=/root/.xauthq2CYTL</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">OPENCL_PROFILE=nvidia</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">UNCACHED_ERR_FD=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">FLTK_DOCDIR=/usr/share/doc/fltk-1.3.5-r4/html</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">NIX_SSL_CERT_FILE=/etc/ssl/certs/ca-certificates.crt</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">OPENGL_PROFILE=xorg-x11</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_FALLBACK=1</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DCC_EMAILLOG_WHOM_TO_BLAME=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">INFOPATH=/usr/share/gcc-data/x86_64-pc-linux-gnu/9.3.0/info:/usr/share/binutils-data/x86_64-pc-linux-gnu/2.35.1/info:/usr/share/info:/usr/share/info/emacs-26</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">JAVAC=/etc/java-config-2/current-system-vm/bin/javac</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LESSOPEN=|lesspipe %s</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">MANPAGER=manpager</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">PATH=/sbin:/bin:/usr/sbin:/usr/bin</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">SUDO_UID=1000</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">MAIL=/var/mail/root</span>
<span style="color: #ff0000;">-</span><span style="color: #ff0000;">_=/bin/env</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_SAVE_TEMPS=0</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PAGER=/usr/bin/less</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_SSH=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">SBCL_HOME=/usr/lib64/sbcl</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">GCC_SPECS=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">GSETTINGS_BACKEND=dconf</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">DISTCC_ENABLE_DISCREPANCY_EMAIL=</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">XDG_DATA_DIRS=/usr/local/share:/usr/share</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">PATH=/root/.nix-profile/bin:/root/.nix-profile/bin:/nix/var/nix/profiles/default/bin:/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/opt/bin:/usr/lib/llvm/11/bin:/opt/plan9/bin:/usr/games/bin</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">VBOX_APP_HOME=/usr/lib64/virtualbox</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LV2_PATH=/usr/lib64/lv2</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">SBCL_SOURCE_ROOT=/usr/lib64/sbcl/src</span>
<span style="color: #00ff00;">+</span><span style="color: #00ff00;">LADSPA_PATH=/usr/lib64/ladspa</span>
+_=/usr/bin/env
</pre>
</div>
</div>
</div>
</div>
</div>

<div id="outline-container-org0d5ea29" class="outline-2">
<h2 id="org0d5ea29">Conclusion</h2>
<div class="outline-text-2" id="text-org0d5ea29">
<p>
Use either <code>sudo -i</code> or <code>su -</code>.  Don't mix <code>sudo</code> and <code>su</code>.  Maybe don't use
<code>sudo</code> (always good advice, though I don't follow it&#x2026; yet).
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
While writing this post, I found that <code>sudo su -</code> will erase <code>SUDO_*</code>
environment variables.  Maybe this is beneficial to a workflow, but in most
cases I suggest fixing your software to not check for these vars.  <a href="https://github.com/winny-/beep/blob/0bd53144a2734ad9fdcb8cb136e4c8594fa9987f/beep-main.c#L480-L494">Looking at
you, <code>beep</code></a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
Thanks to <a href="https://sanctum.geek.nz/">tejr</a> for pointing this out.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Thanks to <a href="https://www.tyil.nl/">tyil</a> for correcting my spelling.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-linux.html">linux</a> <a href="tag-computing.html">computing</a> </div></div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
